using PIbd_24_EredavkinRA_BusBusiness.Forms;
using System.ComponentModel;
using Unity;

namespace PIbd_24_EredavkinRA_BusBusiness;

public partial class FormBus : Form
{
    private readonly IUnityContainer _container;
    public FormBus(IUnityContainer container)
    {
        InitializeComponent();
        _container = container ?? throw new ArgumentException(nameof(container));
    }

    private void StaffToolStripMenuItem_Click(object sender, EventArgs e)
    {
        try
        {
            _container.Resolve<FormStaffes>().ShowDialog();
        }
        catch (Exception ex)
        {
            MessageBox.Show(ex.Message, "  ", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
    }

    private void BusToolStripMenuItem_Click(object sender, EventArgs e)
    {

        try
        {
            _container.Resolve<FormBuses>().ShowDialog();
        }
        catch (Exception ex)
        {
            MessageBox.Show(ex.Message, "  ", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
    }

    private void RoutToolStripMenuItem_Click(object sender, EventArgs e)
    {

        try
        {
            _container.Resolve<FormRoutes>().ShowDialog();
        }
        catch (Exception ex)
        {
            MessageBox.Show(ex.Message, "  ", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
    }

  

    private void RoutSheetToolStripMenuItem_Click(object sender, EventArgs e)
    {

        try
        {
            _container.Resolve<FormRoutSheetes>().ShowDialog();
        }
        catch (Exception ex)
        {
            MessageBox.Show(ex.Message, "  ", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
    }

    private void ToesToolStripMenuItem_Click_1(object sender, EventArgs e)
    {
        try
        {
            _container.Resolve<FormTOes>().ShowDialog();
        }
        catch (Exception ex)
        {
            MessageBox.Show(ex.Message, "  ", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
    }
}
