﻿using PIbd_24_EredavkinRA_BusBusiness.Entities;
using PIbd_24_EredavkinRA_BusBusiness.Repositories;


namespace PIbd_24_EredavkinRA_BusBusiness.Forms;

public partial class FormRoutSheet : Form
{
    private readonly IRoutSheetRepository _routSheetRepository;
    public FormRoutSheet(IBusRepository busRepository, IStaffRepositories staffRepositories, IRoutRepositories routRepositories, IRoutSheetRepository routSheetRepository)
    {
        InitializeComponent();
        _routSheetRepository = routSheetRepository ?? throw new ArgumentNullException(nameof(routSheetRepository));

        comboBoxDriver.DataSource = staffRepositories.ReadStaff();
        comboBoxDriver.DisplayMember = "FirstName";
        comboBoxDriver.DisplayMember = "Id";

        comboBoxConductor.DataSource = staffRepositories.ReadStaff();
        comboBoxConductor.DisplayMember = "FirstName";
        comboBoxConductor.DisplayMember = "Id";

        comboBoxRout.DataSource = routRepositories.ReadRout();
        comboBoxRout.DisplayMember = "NumberRout";
        comboBoxRout.DisplayMember = "Id";




    }

    private void buttonSave_Click(object sender, EventArgs e)
    {
        try
        {
            if (dataGridViewRoutSheet.RowCount < 0 || comboBoxDriver.SelectedIndex < 0 || comboBoxRout.SelectedIndex < 0)
            {
                throw new Exception("Имеются не заполненые поля");
            }
            _routSheetRepository.CreateRoutSheet(RoutSheet.CreatOpeartion(0, (int)comboBoxDriver.SelectedValue!, (int)comboBoxConductor.SelectedValue!,
                (int)comboBoxRout.SelectedValue!, CreateListRoudSheetBusFromDataGrid()));
            Close();
        }
        catch(Exception ex)
        {
            MessageBox.Show(ex.Message, "Ошибка при сохранении", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }

    }

    private void buttonLeave_Click(object sender, EventArgs e) => Close();

    private List<RoutSheetBus> CreateListRoudSheetBusFromDataGrid()
    {
        var list = new List<RoutSheetBus>();
        foreach (DataGridViewRow row in dataGridViewRoutSheet.Rows)
        {
            if (row.Cells["ColumnBus"].Value == null)

            {
                continue;
            }
            list.Add(RoutSheetBus.CreateElement(0,
            Convert.ToInt32(row.Cells["ColumnBus"].Value)));
        }
            
        return list;
    }


}
