﻿using PIbd_24_EredavkinRA_BusBusiness.Repositories;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Unity;

namespace PIbd_24_EredavkinRA_BusBusiness.Forms;

public partial class FormRoutSheetes : Form
{
    private readonly IUnityContainer _container;
    private readonly IRoutSheetRepository _routSheetRepository;
    public FormRoutSheetes(IUnityContainer container, IRoutSheetRepository routSheetRepository)
    {
        InitializeComponent();
        _container = container ?? throw new ArgumentException(nameof(container));
        _routSheetRepository = routSheetRepository ?? throw new ArgumentException(nameof(routSheetRepository));
    }
    private void FormRoutSheetes_Load(object sender, EventArgs e)
    {
        try
        {
            LoadList();
        }
        catch (Exception ex)
        {
            MessageBox.Show(ex.Message, "Ошибка при загрузке", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
    }

    private void buttonadd_Click(object sender, EventArgs e)
    {
        try
        {
            _container.Resolve<FormRoutSheet>().ShowDialog();
            LoadList();
        }
        catch (Exception ex)
        {
            MessageBox.Show(ex.Message, "Ошибка при добавлении", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }

    }
    private void LoadList() => dataGridViewData.DataSource = _routSheetRepository.ReadRoutSheet();

   
}
