﻿using PIbd_24_EredavkinRA_BusBusiness.Entities;
using PIbd_24_EredavkinRA_BusBusiness.Repositories;


namespace PIbd_24_EredavkinRA_BusBusiness.Forms;

public partial class FormTO : Form
{
    private readonly IToRepository _toRepository;
   

    public FormTO(IToRepository toRepository, IStaffRepositories staffRepositories, IBusRepository busRepository)
    {
        InitializeComponent();
        _toRepository = toRepository ?? throw new ArgumentNullException(nameof(toRepository));

        comboBoxStaff.DataSource = staffRepositories.ReadStaff();
        comboBoxStaff.DisplayMember = "FirstName";
        comboBoxStaff.ValueMember = "Id";

        comboBoxBus.DataSource = busRepository.ReadBus();
        comboBoxBus.DisplayMember = "N_Z";
        comboBoxBus.ValueMember = "Id";
    } 

    private void buttonSave_Click(object sender, EventArgs e)
    {
        try
        {
            if (comboBoxStaff.SelectedIndex < 0 || comboBoxBus.SelectedIndex < 0 || string.IsNullOrWhiteSpace(textBoxDescription.Text))
            {
                throw new Exception("Имеются не заполненые поля");
            }
            _toRepository.CreateTo(To.CreatOperation(0, textBoxDescription.Text, Convert.ToInt32(numericUpDownCost.Value), (int)comboBoxBus.SelectedValue!,
                (int)comboBoxStaff.SelectedValue!));
            Close();
        }
        catch (Exception ex)
        {
            MessageBox.Show(ex.Message, "Ошибка при сохранении", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }


    }
   


    private void buttonLeave_Click(object sender, EventArgs e) => Close();

    


}
